
_atcacert_verify_cert_sw:
	LNK	#96

	PUSH	W10
	PUSH	W11
	PUSH	W12
	CP	W10, #0
	BRA NZ	L__atcacert_verify_cert_sw19
	GOTO	L__atcacert_verify_cert_sw13
L__atcacert_verify_cert_sw19:
	CP	W13, #0
	BRA NZ	L__atcacert_verify_cert_sw20
	GOTO	L__atcacert_verify_cert_sw12
L__atcacert_verify_cert_sw20:
	CP	W11, #0
	BRA NZ	L__atcacert_verify_cert_sw21
	GOTO	L__atcacert_verify_cert_sw11
L__atcacert_verify_cert_sw21:
	GOTO	L_atcacert_verify_cert_sw2
L__atcacert_verify_cert_sw13:
L__atcacert_verify_cert_sw12:
L__atcacert_verify_cert_sw11:
	MOV	#2, W0
	GOTO	L_end_atcacert_verify_cert_sw
L_atcacert_verify_cert_sw2:
	ADD	W14, #0, W0
	PUSH.D	W12
	PUSH.D	W10
	MOV	W0, W13
	CALL	_atcacert_get_tbs_digest
	POP.D	W10
	POP.D	W12
; ret start address is: 2 (W1)
	MOV	W0, W1
	CP	W0, #0
	BRA NZ	L__atcacert_verify_cert_sw22
	GOTO	L_atcacert_verify_cert_sw3
L__atcacert_verify_cert_sw22:
	MOV	W1, W0
; ret end address is: 2 (W1)
	GOTO	L_end_atcacert_verify_cert_sw
L_atcacert_verify_cert_sw3:
	MOV	#32, W0
	ADD	W14, W0, W0
	PUSH	W13
	MOV	W0, W13
	CALL	_atcacert_get_signature
	POP	W13
; ret start address is: 2 (W1)
	MOV	W0, W1
	CP	W0, #0
	BRA NZ	L__atcacert_verify_cert_sw23
	GOTO	L_atcacert_verify_cert_sw4
L__atcacert_verify_cert_sw23:
	MOV	W1, W0
; ret end address is: 2 (W1)
	GOTO	L_end_atcacert_verify_cert_sw
L_atcacert_verify_cert_sw4:
	MOV	#32, W1
	ADD	W14, W1, W1
	ADD	W14, #0, W0
	MOV	W13, W12
	MOV	W1, W11
	MOV	W0, W10
	CALL	_atcac_sw_ecdsa_verify_p256
; ret start address is: 2 (W1)
	MOV	W0, W1
	CP	W0, #0
	BRA NZ	L__atcacert_verify_cert_sw24
	GOTO	L_atcacert_verify_cert_sw5
L__atcacert_verify_cert_sw24:
	MOV	W1, W0
; ret end address is: 2 (W1)
	GOTO	L_end_atcacert_verify_cert_sw
L_atcacert_verify_cert_sw5:
	CLR	W0
L_end_atcacert_verify_cert_sw:
	POP	W12
	POP	W11
	POP	W10
	ULNK
	RETURN
; end of _atcacert_verify_cert_sw

_atcacert_gen_challenge_sw:
	LNK	#0

	PUSH	W11
	CP	W10, #0
	BRA Z	L__atcacert_gen_challenge_sw26
	GOTO	L_atcacert_gen_challenge_sw6
L__atcacert_gen_challenge_sw26:
	MOV	#2, W0
	GOTO	L_end_atcacert_gen_challenge_sw
L_atcacert_gen_challenge_sw6:
	MOV	#32, W11
	CALL	_atcac_sw_random
L_end_atcacert_gen_challenge_sw:
	POP	W11
	ULNK
	RETURN
; end of _atcacert_gen_challenge_sw

_atcacert_verify_response_sw:
	LNK	#0

	PUSH	W10
	PUSH	W11
	PUSH	W12
	CP	W10, #0
	BRA NZ	L__atcacert_verify_response_sw28
	GOTO	L__atcacert_verify_response_sw17
L__atcacert_verify_response_sw28:
	CP	W11, #0
	BRA NZ	L__atcacert_verify_response_sw29
	GOTO	L__atcacert_verify_response_sw16
L__atcacert_verify_response_sw29:
	CP	W12, #0
	BRA NZ	L__atcacert_verify_response_sw30
	GOTO	L__atcacert_verify_response_sw15
L__atcacert_verify_response_sw30:
	GOTO	L_atcacert_verify_response_sw9
L__atcacert_verify_response_sw17:
L__atcacert_verify_response_sw16:
L__atcacert_verify_response_sw15:
	MOV	#2, W0
	GOTO	L_end_atcacert_verify_response_sw
L_atcacert_verify_response_sw9:
	PUSH	W11
	MOV	W12, W11
	MOV	W10, W12
	POP	W10
	CALL	_atcac_sw_ecdsa_verify_p256
L_end_atcacert_verify_response_sw:
	POP	W12
	POP	W11
	POP	W10
	ULNK
	RETURN
; end of _atcacert_verify_response_sw
