
_hal_iface_init:
	LNK	#0

; status start address is: 2 (W1)
	MOV.B	#240, W1
	MOV	W10, W2
	GOTO	L_hal_iface_init0
; status end address is: 2 (W1)
L_hal_iface_init2:
	MOV	#lo_addr(_hal_i2c_init), W0
	MOV	W0, [W11]
	ADD	W11, #2, W1
	MOV	#lo_addr(_hal_i2c_post_init), W0
	MOV	W0, [W1]
	ADD	W11, #6, W1
	MOV	#lo_addr(_hal_i2c_receive), W0
	MOV	W0, [W1]
	ADD	W11, #4, W1
	MOV	#lo_addr(_hal_i2c_send), W0
	MOV	W0, [W1]
	ADD	W11, #12, W1
	MOV	#lo_addr(_hal_i2c_sleep), W0
	MOV	W0, [W1]
	ADD	W11, #8, W1
	MOV	#lo_addr(_hal_i2c_wake), W0
	MOV	W0, [W1]
	ADD	W11, #10, W1
	MOV	#lo_addr(_hal_i2c_idle), W0
	MOV	W0, [W1]
	ADD	W11, #14, W1
	MOV	#lo_addr(_hal_i2c_release), W0
	MOV	W0, [W1]
	ADD	W11, #16, W1
	CLR	W0
	MOV	W0, [W1]
; status start address is: 0 (W0)
	CLR	W0
	MOV.B	W0, W1
; status end address is: 0 (W0)
	GOTO	L_hal_iface_init1
L_hal_iface_init3:
; status start address is: 2 (W1)
	GOTO	L_hal_iface_init1
L_hal_iface_init4:
	GOTO	L_hal_iface_init1
L_hal_iface_init5:
	GOTO	L_hal_iface_init1
L_hal_iface_init6:
	GOTO	L_hal_iface_init1
L_hal_iface_init0:
	MOV.B	[W2], W0
	CP.B	W0, #0
	BRA NZ	L__hal_iface_init15
	GOTO	L_hal_iface_init2
L__hal_iface_init15:
	MOV.B	[W2], W0
	CP.B	W0, #1
	BRA NZ	L__hal_iface_init16
	GOTO	L_hal_iface_init3
L__hal_iface_init16:
	MOV.B	[W2], W0
	CP.B	W0, #2
	BRA NZ	L__hal_iface_init17
	GOTO	L_hal_iface_init4
L__hal_iface_init17:
	MOV.B	[W2], W0
	CP.B	W0, #3
	BRA NZ	L__hal_iface_init18
	GOTO	L_hal_iface_init5
L__hal_iface_init18:
	MOV.B	[W2], W0
	CP.B	W0, #4
	BRA NZ	L__hal_iface_init19
	GOTO	L_hal_iface_init6
L__hal_iface_init19:
; status end address is: 2 (W1)
L_hal_iface_init1:
; status start address is: 2 (W1)
	MOV.B	W1, W0
; status end address is: 2 (W1)
L_end_hal_iface_init:
	ULNK
	RETURN
; end of _hal_iface_init

_hal_iface_release:
	LNK	#0

	PUSH	W10
; status start address is: 2 (W1)
	MOV.B	#225, W1
	GOTO	L_hal_iface_release7
; status end address is: 2 (W1)
L_hal_iface_release9:
	MOV	W11, W10
	CALL	_hal_i2c_release
; status start address is: 2 (W1)
	MOV.B	W0, W1
	GOTO	L_hal_iface_release8
L_hal_iface_release10:
	GOTO	L_hal_iface_release8
L_hal_iface_release11:
	GOTO	L_hal_iface_release8
L_hal_iface_release12:
	GOTO	L_hal_iface_release8
L_hal_iface_release13:
	GOTO	L_hal_iface_release8
L_hal_iface_release7:
	CP.B	W10, #0
	BRA NZ	L__hal_iface_release21
	GOTO	L_hal_iface_release9
L__hal_iface_release21:
	CP.B	W10, #1
	BRA NZ	L__hal_iface_release22
	GOTO	L_hal_iface_release10
L__hal_iface_release22:
	CP.B	W10, #2
	BRA NZ	L__hal_iface_release23
	GOTO	L_hal_iface_release11
L__hal_iface_release23:
	CP.B	W10, #3
	BRA NZ	L__hal_iface_release24
	GOTO	L_hal_iface_release12
L__hal_iface_release24:
	CP.B	W10, #4
	BRA NZ	L__hal_iface_release25
	GOTO	L_hal_iface_release13
L__hal_iface_release25:
; status end address is: 2 (W1)
L_hal_iface_release8:
; status start address is: 2 (W1)
	MOV.B	W1, W0
; status end address is: 2 (W1)
L_end_hal_iface_release:
	POP	W10
	ULNK
	RETURN
; end of _hal_iface_release
